<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="医生名称" prop="doctorName" >
        <el-input
          v-model="queryParams.doctorName"
          placeholder="请输入医生名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="客户名称" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入客户名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="客服角色" prop="roleId">
        <el-select v-model="queryParams.roleId" placeholder="请选择客服角色" clearable size="small">
          <el-option
                v-for="item in roles"
                :key="item.roleId"
                :label="item.roleName"
                :value="item.roleId"
              />
        </el-select>
      </el-form-item>

      <el-form-item label="发送时间" prop="createTime">
        <el-date-picker
           style="width:220px"
           clearable size="small"
           v-model="dateRange"
           type="daterange"
           value-format="yyyy-MM-dd"
           start-placeholder="开始日期"
           end-placeholder="结束日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['chat:chatMsg:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="chatMsgList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="ID" align="center" prop="msgId" /> -->
      <el-table-column label="会话ID" align="center" prop="sessionId" />
      <el-table-column label="所属医生" align="center" prop="doctorName" />
      <el-table-column label="用户" align="center" prop="userName" />
      <el-table-column label="头像" width="150" align="center">
        <template slot-scope="scope">
          <img :src="scope.row.userAvatar" style="height: 80px">
        </template>
      </el-table-column>
      <el-table-column label="AI客服" align="center" prop="roleName" />
      <el-table-column show-overflow-tooltip label="消息内容" align="center" prop="content" />

      <el-table-column  label="发送方式"  align="center" prop="sendType">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.msgType === 1">用户发送</el-tag>
          <el-tag v-else-if="scope.row.msgType === 2">AI发送</el-tag>
        </template>
      </el-table-column>

      <el-table-column label="发送时间" align="center" prop="createTime" />
      <!-- <el-table-column label="操作" align="center" class-name="small-padding fixed-width" >
        <template slot-scope="scope">
          <el-button
            v-if="scope.row.status==2 && scope.row.sendType==2"
            size="mini"
            type="text"
            @click="handleEditMsg(scope.row)"
            v-hasPermi="['chat:chatMsg:edit']"
          >修改内容</el-button>
        </template>
      </el-table-column> -->
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改聊天消息记录对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form"  label-width="80px">
        <el-form-item label="提问消息">
          <el-input type="textarea" v-model="form.userContent" :rows="8" readonly/>
        </el-form-item>
        <el-form-item label="回答内容">
          <el-input type="textarea" v-model="form.content" :rows="8"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listChatMsg, getChatMsg, delChatMsg, addChatMsg, updateChatMsg, exportChatMsg } from "@/api/chat/chatMsg";
import { listMsg } from "@/api/aiDpctorChat/aiDoctorChat";
import { getAllRoleList } from "@/api/chat/chatRole";
import {allList} from "@/api/company/company";

export default {
  name: "ChatMsg",
  data() {
    return {
      companyList:[],
      userContent:null,
      statusOptions:[],
      show:{
              title:"聊天详情",
              open:false,
            },
      roles:[],
      dateRange:[],
      typeOptions:[],
      sendTypeOptions:[],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 聊天消息记录表格数据
      chatMsgList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        chatId: null,
        content: null,
        msgType: null,
        sendType: null,
        companyId: null,
        roleId: null,
        status:null,
        companyUserId: null,
        msgJson: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getAllCompany();
    this.getDicts("chat_msg_type").then((response) => {
      this.typeOptions = response.data;
    });
    this.getDicts("sys_chat_msg_status").then((response) => {
      this.statusOptions = response.data;
    });
    this.getDicts("chat_msg_send_type").then((response) => {
      this.sendTypeOptions = response.data;
    });
    getAllRoleList().then(response => {
        this.roles = response.data;
    });
    this.getList();
  },
  methods: {
    getAllCompany() {
      allList().then(response => {
        this.companyList = response.rows;
        this.companyList.push({dictLabel: "无",
          dictValue: "0"})
      });
    },
    handleEditMsg(row){
      this.reset();
      const msgId = row.msgId || this.ids
      getChatMsg(msgId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改聊天消息";
      });
    },
    handleShow(){

    },
    /** 查询聊天消息记录列表 */
    getList() {
      this.loading = true;
      listMsg(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.chatMsgList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    handledetails(row){
       this.show.open=true;
       setTimeout(() => {
            this.$refs.Details.getDetails(row.msgId);
       }, 1);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        msgId: null,
        chatId: null,
        content: null,
        userContent: null,
        msgType: null,
        sendType: null,
        companyId: null,
        roleId: null,
        companyUserId: null,
        createTime: null,
        msgJson: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.dateRange=null
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.msgId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加聊天消息记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const msgId = row.msgId || this.ids
      getChatMsg(msgId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改聊天消息记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.msgId != null) {
            this.form.status = null;
            updateChatMsg(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addChatMsg(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const msgIds = row.msgId || this.ids;
      this.$confirm('是否确认删除聊天消息记录编号为"' + msgIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delChatMsg(msgIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有聊天消息记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportChatMsg(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>

<style lang="css">
  .el-tooltip__popper{
    max-width:40%
  }
</style>
